# Kraken Root Component

[![Build Status](https://travis-ci.org/kraken-php/framework.svg)](https://travis-ci.org/kraken-php/framework)
[![Total Downloads](https://poser.pugx.org/kraken-php/root/downloads)](https://packagist.org/packages/kraken-php/root) 
[![Latest Stable Version](https://poser.pugx.org/kraken-php/root/v/stable)](https://packagist.org/packages/kraken-php/root) 
[![Latest Unstable Version](https://poser.pugx.org/kraken-php/root/v/unstable)](https://packagist.org/packages/kraken-php/root) 
[![License](https://poser.pugx.org/kraken-php/framework/license)](https://packagist.org/packages/kraken-php/framework)
[![Kraken Compatible](https://img.shields.io/badge/kraken-compatible-6b02af.svg)](https://github.com/kraken-php/framework)

> **Note:** This repository is a part of [Kraken Framework][3], but **can be used freely as standalone library**. If you 
are interested in more asynchronous components for PHP, check out the rest of [Kraken repository][5] or see our 
[asynchronous application skeleton][4] example.

## Description

Root fulfills the role of application composition root. It consists of pre-configured providers, bootloaders and
core configurations for Kraken console processes and runtime containers.

## Feature Highlights

Root features:

* Default definition providers for Kraken Framework,
* Default logic providers for Kraken Framework,
* Pre-defined configuration for console Client and Server,
* Pre-defined configuration for runtime containers,
* ...and more.

## Examples

See more examples in [official documentation][2].

## Requirements

* PHP-5.5, PHP-5.6 or PHP-7.0+,
* UNIX or ~~Windows~~ OS.

## Installation

```
composer require kraken-php/root
```

## Tests

Tests are provided within our write-only [Framework repository][3].

## Documentation

Documentation for this module can be found in the [official documentation][2].

## Contributing

This library is read-only subtree split of Kraken Framework. To make contributions, please go to [Framework repository][3].

## License

This library licensed under the MIT license, see more information in [Kraken Framework][3] license section.

[1]: http://kraken-php.com
[2]: http://kraken-php.com/docs/api-root
[3]: https://github.com/kraken-php/framework
[4]: https://github.com/kraken-php/kraken
[5]: https://github.com/kraken-php
